// File...: Udpcltl.c
// Version: 1.00 (Build 1 - Linux Version)
// Date...: 21.April.2001 (kdw@ist1.de)
// (c) Klaus-D. Walter. All Rights reserved.

//              *** DISCLAIMER OF WARRENTY ***
// =======================================================
// THIS  CODE AND INFORMATION IS PROVIDED "AS IS"  WITHOUT
// A  WARRANTY OF  ANY KIND, EITHER  EXPRESSED OR  IMPLIED,
// INCLUDING  BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

// Includes

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

// Function prototype

int  main      (int, char **);      // The one and only main function
void UdpClient (char *, short);     // Send data to Server...

/////////////////////////////////////////////////////////////////////////////
// main

int main (int argc, char **argv)
{
   long lRet;

   // Check for the host and port arguments. Print usage if errors...

   if (argc != 3) {
      printf ("\n  Client usage: UdpcltW ServerIpAddr PortNumber.");
      printf ("\n  Example.....: UdpcltW 192.168.0.125 5000<enter>\n\n");
      return (1);
	 }

   // Check for valid IP address...

   lRet= inet_addr (argv[1]);
   if (lRet == INADDR_NONE) {
      printf ("\n  No valid IP address for UDP Server.\n\n");
      return (1);
   }

	 // Go do all the stuff a datagram client does...

   UdpClient (argv[1], atoi (argv[2]));
   printf ("\n");
   return (1);
}

/////////////////////////////////////////////////////////////////////////////
/// UdpClient

void UdpClient (char *szServer, short nPort)
{
   char szBuf[256];
   int  nRet, nFromLen, theSocket;
   struct sockaddr_in saServer;

   // Show client version and port number...

   printf ("\n  UDP Client (Linux) Vers. 1.00 is using port \"%d\"", nPort);
   printf ("\n  =============================================================");

   // Create a UDP/IP datagram socket...

   theSocket= socket (AF_INET, SOCK_DGRAM, 0);

   // ... and check for error...

   if (theSocket < 0) {
      printf ("\n  Cant create Socket.\n");
      return;
   }

   // Fill in the address structure for the server address and port number...

   saServer.sin_family= AF_INET;
   saServer.sin_port= htons (nPort);
   saServer.sin_addr.s_addr= inet_addr (szServer);

   // Send data to the server...
	
   printf ("\n  Send data to server addr %s: Hello from Client", szServer);
   strcpy (szBuf, "Hello from Client");
   nRet= sendto (theSocket, szBuf, strlen (szBuf), 0, &saServer, sizeof (struct sockaddr));

   // ... and check for any errors...

   if (nRet < 0) {
      printf ("\n  Error in sendto function.\n");
      close (theSocket);
	  return;
   }

   // Wait for server reply data...

   printf ("\n  Wait for server reply data...");
   memset (szBuf, 0, sizeof (szBuf));
   nFromLen= sizeof (struct sockaddr);
   recvfrom (theSocket, szBuf, sizeof (szBuf), 0, &saServer, &nFromLen);

   // ... and check for any errors...

   if (nRet < 0) {
      printf ("\n  Error in recvform function.\n");
      close (theSocket);
	  return;
   }

   // Display the reply data...

   printf ("\r  Data from addr %s received : %s\n", inet_ntoa (saServer.sin_addr), szBuf);

   // Exit this client code...

   close (theSocket);
   return;
}
